datablock ShapeBaseImageData(TauHelmetImage)
{
	shapeFile = "./tauhelmet.dts";
	mountPoint = 5;

	eyeOffset = "0 0 10";

	doColorShift = 1;
	colorShiftColor = "0.855 0.647 0.121 1.0";
};

datablock ShapeBaseImageData(TauShoulderpadImage)
{
	shapeFile = "./taushoulderpad.dts";
	mountPoint = 2;

	offset = "-0.65 0 -0.05";
	eyeOffset = "0 0 10";

	doColorShift = 1;
	colorShiftColor = "0.855 0.647 0.121 1.0";
};

function spawnRobot(%transform)
{
	%obj = new AIPlayer()
	{
		datablock = PlayerStandardArmor;
	};

	MissionCleanup.add(%obj);

	%obj.setTransform(%transform);
	%obj.setScale("1 1 1.1");

	%obj.mountImage(TauHelmetImage, 2);
	%obj.mountImage(TauShoulderpadImage, 1);

	%obj.unHideNode("armor");
	%obj.setNodeColor("armor", "0.855 0.647 0.121 1.0");
	%obj.setNodeColor("pants", "0.855 0.647 0.121 1.0");
	%obj.setNodeColor("larm", "0.855 0.647 0.121 1.0");
	%obj.setNodeColor("rarm", "0.855 0.647 0.121 1.0");
	%obj.setNodeColor("lhand", "0.855 0.647 0.121 1.0");
	%obj.setNodeColor("rhand", "0.855 0.647 0.121 1.0");

	%obj.schedule(500, followPlayer, findLocalClient().player);
	return %obj;
}

function AIPlayer::followPlayer(%this, %obj, %lastPos, %lastVel, %lastSim)
{
	cancel(%this.followPlayer);

	if (!isObject(%obj) || %obj.getState() $= "Dead")
	{
		return;
	}

	%this.maxYawSpeed = 4;

	%fov = %this.hasFOV(%obj);
	%los = %this.hasLOS(%obj);

	if (%fov && %los)
	{
		%lastPos = %obj.getPosition();
		%lastVel = %obj.getVelocity();
		%lastSim = $Sim::Time;

		%this.setMoveObject(%obj);
		%this.setAimObject(%obj);

		createLine("0 1 0 1", %this.getEyePoint(), %obj.getPosition(), 0.01, 100);
	}
	else if (%lastPos !$= "")
	{
		%aimVel = setWord(%lastVel, 2, 0);
		%aimPoint = vectorAdd(%lastPos, vectorScale(%aimVel, $Sim::Time - %lastSim));

		%this.setMoveObject(0);

		%this.setMoveDestination(%lastPos);
		%this.setAimLocation(%aimPoint);

		createLine("0 0 1 1", %lastPos, %aimPoint, 0.01, 100);
		createLine("0 1 1 1", %this.getEyePoint(), %lastPos, 0.01, 100);
	}
	else
	{
		%this.clearAim();
		%this.stop();
	}

	%this.followPlayer = %this.schedule(100, followPlayer, %obj, %lastPos, %lastVel, %lastSim);
}

function AIPlayer::hasFOV(%this, %obj, %fov)
{
	if (%fov $= "")
	{
		%fov = 90;
	}

	%diff = vectorSub(%obj.getPosition(), %this.getPosition());
	%diff = setWord(%diff, 2, 0);

	%product = vectorDot(%this.getForwardVector(), vectorNormalize(%diff));
	return %product >= 1 - (%fov / 360) * 2;
}

function AIPlayer::hasLOS(%this, %obj)
{
	%eye = %this.getEyePoint();
	%box = %obj.getWorldBox();

	%z1 = getWord(%box, 2);
	%z2 = %z1 + (getWord(%box, 5) - %z1) / 3.5;

	%xy = getWords(%obj.getPosition(), 0, 1);
	%step = (%z2 - %z1) / 10;

	for (%z = %z1; %z <= %z2; %z += %step)
	{
		%ray = containerRayCast(%eye, %xy SPC %z, $TypeMasks::FxBrickObjectType);

		if (!%ray)
		{
			return 1;
		}
	}

	return 0;
}